pipeline {
    agent any
    options {
        buildDiscarder(logRotator(numToKeepStr: '10'))
    }
  environment {
   PATH ="/var/lib/jenkins/miniconda3/bin:$PATH"
  }
  stages {
      stage('Checkout') {
          steps{
               sshagent(credentials : ['BitBucket_SSH']) {
                   sh 'ssh -o StrictHostKeyChecking=no acharyak@bitbucket.org'
                   sh 'ssh -v acharyak@bitbucket.org'
                   sh '''#!/bin/bash -l
                export PATH=/var/lib/jenkins/miniconda3/bin:$PATH
		        sed -i 's,^\\(build=\\).*,\\1'${BUILD_NUMBER}',g' version.txt
		        sed -i 's,^\\(date=\\).*,\\1'${BUILD_TIMESTAMP}',g' version.txt
		        sed -i 's,^\\(gitCommitId=\\).*,\\1'$(git rev-parse --short HEAD)',g' version.txt
                make image_clean
                cd build
                cd platform
                source activate py27
                python --version
                make base_sd
                cd ../..
                source setup-imx-environment
                ctb re-init
                ctb build imx
                ctb install
                make CD=D2
                '''
               }
          }
      }
    stage('Test') {
      steps {
        sh 'bash ./ctb citest'
      }
    }
    stage('Publish SD Card Image on BitBucket') {
        steps {
            dir('build/sd_images/'){
                sh '''
                    curl -X POST https://djiang2014:XLcFH3CfyHHZs5qDXSr4@api.bitbucket.org/2.0/repositories/djiang2014/contower/downloads -F files=@$(find -name *.img.bz2 -printf '%f')
                '''
            }
        }
    }
    stage('Copy SD Card Image (bz2) to the Shared drive'){
        steps{
                dir('build/sd_images/') {
                cifsPublisher(publishers: [[
                configName: 'RD_Data',
                transfers: [[cleanRemote: false,
                excludes: '',
                flatten: false,
                makeEmptyDirs: true,
                noDefaultExcludes: false,
                patternSeparator: '/',
                remoteDirectory: "/images_from_jenkins/${BUILD_TIMESTAMP}/",
                remoteDirectorySDF: false,
                removePrefix: '',
                sourceFiles: '*.img.bz2' ]],
                usePromotionTimestamp: false,
                useWorkspaceInPromotion: false,
                verbose: true]]
                )
    		}
    	}
    }
    stage('Copy SD Card Image (zip for Etcher) to the Shared drive'){
        steps{
                dir('build/sd_images/') {
                cifsPublisher(publishers: [[
                configName: 'RD_Data',
                transfers: [[cleanRemote: false,
                excludes: '',
                flatten: false,
                makeEmptyDirs: true,
                noDefaultExcludes: false,
                patternSeparator: '/',
                remoteDirectory: "/images_from_jenkins/${BUILD_TIMESTAMP}/",
                remoteDirectorySDF: false,
                removePrefix: '',
                sourceFiles: '*.zip' ]],
                usePromotionTimestamp: false,
                useWorkspaceInPromotion: false,
                verbose: true]]
                )
                }
        }
    }
}
  post {
        always {
            sh 'conda remove --yes -n ${BUILD_TAG} --all'
            emailext body: "${currentBuild.currentResult}: Job ${env.JOB_NAME} build ${env.BUILD_NUMBER}\n More info at: ${env.BUILD_URL}", attachLog:true, compressLog:true,
            recipientProviders: [[$class: 'DevelopersRecipientProvider'], [$class: 'RequesterRecipientProvider']],
            subject: "Jenkins Build ${currentBuild.currentResult}: Job ${env.JOB_NAME}", to:'akshay.acharya@smith-nephew.com'
        }
    }
}
